﻿using System;
using System.Net;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Drawing;

namespace LovciPokladuNew
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        List<string> data;
        Button[,] policka = new Button[10, 10];
        string rozehranaURL;
        int idHry, meTahy, souperovyTahy, mujNesenyPoklad,
            souperuvNesenyPoklad, mujCelkovyPoklad, souperuvCelkovyPoklad, 
            mojeX, mojeY, souperovoX, souperovoY;

        private void Form1_Load(object sender, EventArgs e)
        {
            
            //příprava políček
            for (int x = 0; x < 10; x++)
                for (int y = 0; y < 10; y++)
                { 
                    Button pole = new Button();
                    pole.Location = new Point(groupBox1.Width / 10 * x,
                        groupBox1.Height / 10 * y + 12);
                    pole.Click += pole_Click;
                    pole.Size = new System.Drawing.Size(40, 35);
                    pole.Tag = string.Concat(x, ";", y);
                    pole.BackColor = SystemColors.ControlDark;
                    groupBox1.Controls.Add(pole);
                    policka[x, y] = pole;
                }
        }

        private void nováHraToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (meTahy != 0)
                if (MessageBox.Show("Opravdu chcete začít novou hru ?", "Nová hra", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
                    return;

            policka[mojeX, mojeY].BackColor = SystemColors.ControlDark; // odbarvení pole
            var kusy = urlTB.Text.Split('/');
            rozehranaURL = string.Concat(@"http://", kusy[2], @"/");
           nactiMapu(urlTB.Text);//startovní požadavek na server
        }

        private void nactiMapu(string url)
        {
            data = new List<string>();
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            using (StreamReader reader = new StreamReader(response.GetResponseStream()))
            {
                string line = "";
                while ((line = reader.ReadLine()) != null)
                {
                    data.Add(line);
                }
            }
            if (!int.TryParse(data[0], out idHry))
            {
                MessageBox.Show(data[0]);
                if (MessageBox.Show("Chcete začít novou hru ?", "Nová hra", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    meTahy = 0;
                    nováHraToolStripMenuItem_Click(null, null);
                }
                return;
            }

            meTahy = souperovyTahy = int.Parse(data[1]);
            textBox1.Text = meTahy.ToString();

            //spracování mapy
            for (int y = 0; y < 10; y++)
                for (int i = 0; i < 19; i += 2)
                {
                    policka[i / 2, y].Enabled = true;
                    switch (data[y + 2][i])
                    {
                        case '-':
                        case 'X':
                            policka[i / 2, y].Text = string.Concat(data[y + 2][i], data[y + 2][i]); // napsání znaku na talčítko původně jsem chtěl i textový tooltip
                            policka[i / 2, y].Enabled = false; //automaticky znemožní vtup na tlačítko
                            break;

                        case '.':
                        case '+':                        
                            policka[i / 2, y].Text = string.Concat(data[y + 2][i], data[y + 2][i]); // napsání znaku na talčítko původně jsem chtěl i textový tooltip
                            break;
                        //hodnota pokaldu
                        default:
                            policka[i / 2, y].Text = string.Concat(data[y + 2][i], data[y + 2][i + 1]);
                            break;
                    }

                }
            //zvýraznit hráče
            var cisla = data[12].Split(' ');
            policka[mojeX = int.Parse(cisla[0]) - 1,mojeY = int.Parse(cisla[1]) - 1].BackColor = SystemColors.MenuHighlight;
            mujNesenyPoklad = int.Parse(cisla[2]);
            textBox2.Text = mujNesenyPoklad.ToString();
            mujCelkovyPoklad = int.Parse(cisla[3]);
            textBox3.Text = mujCelkovyPoklad.ToString();
            textBox4.Text = mojeX.ToString();
            textBox5.Text = mojeY.ToString();

            //zjistit soupeře
            if (data[13].Length > 0)
            {
              cisla = data[13].Split(' ');
              policka[souperovoX = int.Parse(cisla[0]) - 1, souperovoY = int.Parse(cisla[1]) - 1].BackColor = Color.Red;
              policka[souperovoX = int.Parse(cisla[0]) - 1, souperovoY = int.Parse(cisla[1]) - 1].Enabled = false;
              souperuvNesenyPoklad = int.Parse(cisla[2]);
              souperuvCelkovyPoklad = int.Parse(cisla[3]);
            }
        }

        private void nápovědaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Hra se ovládá kliknutím na políčko. Lze se posunovat nahoru, dolu, doleva, doprava.");
        }

        void pole_Click(object sender, EventArgs e)
        {
          //kontrola vzdálenosti
            var policko = ((Button)sender);
            var cisla = policko.Tag.ToString().Split(';');  //x;y

            if (mojeX - int.Parse(cisla[0]) == -1 && Math.Abs(mojeY - int.Parse(cisla[1])) == 0) //doprava P
                AkceSPolickem(policko, "P");

            if (mojeX - int.Parse(cisla[0]) == 1 && Math.Abs(mojeY - int.Parse(cisla[1])) == 0) //doleva L
                AkceSPolickem(policko, "L");

            if (mojeY - int.Parse(cisla[1]) == -1 && Math.Abs(mojeX - int.Parse(cisla[0])) == 0) // dolů D
                AkceSPolickem(policko, "D");

            if (mojeY - int.Parse(cisla[1]) == 1 && Math.Abs(mojeX - int.Parse(cisla[0])) == 0) // nahoru
                AkceSPolickem(policko, "N");

        }

        private void AkceSPolickem(Button pole, string smer)
        {
            if (pole.Enabled) //pokud je přístupné tak na něj vstup a zkontroluj 
            {
                        /*policka[mojeX, mojeY].BackColor = SystemColors.ControlDark;
                        pole.BackColor = SystemColors.MenuHighlight;
                        var cisla = pole.Tag.ToString().Split(';');
                        mojeX = int.Parse(cisla[0]);
                        mojeY = int.Parse(cisla[1]);*/
                        //urlTB.Text = rozehranaURL + "tah?id=" + idHry + "&pohyb=" + smer;

                policka[mojeX, mojeY].BackColor = SystemColors.ControlDark; // odbarvení pole
                nactiMapu(rozehranaURL + "tah?id=" + idHry + "&pohyb=" + smer);

            }
            else
                MessageBox.Show("Neplatný tah!");
        }
    }
}
